<template>
  <div class="organization-page">
    <template v-if="notEmptyGroups.length">
      <ObFunctionalPanel
        :columns="columns"
        :show-refresh="true"
        :show-edit="isEditEnabled"
        :show-group="false"
        :show-sort="false"
        :loading="pending"
        @search="onSearch"
        @onEdit="onEdit"
        @onRefresh="onRefresh"
        @toggleColumnVisibility="onToggleColumnVisibility"
      />

      <div
        class="ob-accordion__item"
        v-show="tableIsShown(index)"
        v-for="(group, index) in notEmptyGroups"
        :key="group.requisiteGroupUuid"
      >
        <div class="ob-accordion__title" @click="onAccordionClick(group)">
          <i
            :class="['icon chevron-down', group._isOpen ? 'opened' : 'closed']"
          />
          <div class="ob-accordion__title-text">
            {{ group.requisiteGroupTitle }}
          </div>
        </div>

        <div
          v-if="group._isOpen"
          class="ob-accordion__content"
        >
          <ObTable
            :ref="'requisites-grid-' + index"
            :data-attr="group['data-attr']"
            :items="group.fields"
            :columns="columns"
            :selected="selectedField"
            :footer-disabled="true"
            :search-query="searchQuery"
            :options-save-row="optionsTableSaveItem"
            :table-layout-fixed="index !== notEmptyGroups.length - 1"
            @select="onSelect"
          >
            <template
              slot="title"
              slot-scope="{ data }"
            >
              <div class="title-container">
                <template v-if="!data.item.isAttach && data.item.fieldValues.length > 1">
                  <div
                    v-if="isResolvedConflict(data.item.fieldValues)"
                    class="status-container"
                    title="Расхождение в данных решено"
                  >
                    <i class="icon checked -caribbean-green" />
                  </div>

                  <div
                    v-else
                    class="status-container"
                    title="Расхождение в данных"
                  >
                    <i class="icon alert -light-raspberry-red" />
                  </div>
                </template>

                <div
                  v-else
                  class="status-container-empty"
                />

                <div class="title-index">{{ data.item.index }}</div>
                <div class="title-text">{{ data.item.fieldTitle }}</div>
              </div>
            </template>
          </ObTable>
        </div>
      </div>
    </template>

    <ObLoader
      v-else
      class="organization-page-loader"
    />

    <div
      v-if="error"
      class="error"
    >
      {{ error }}
    </div>

    <ObModal
      ref="ob-modal-view-values"
      size="large"
      :title="getFieldsModalTitleByValues(selectedField)"
      :is-read-only="true"
      :is-show-controls="true"
      :is-center="false"
    >
      <ViewValues
        :fields="selectedField.fieldValues"
        :title="selectedField.fieldTitle"
      />
    </ObModal>

    <ObModal
      ref="org-history"
      custom-class="modal-large"
      title="История изменений оценки"
      :is-show-controls="true"
      :is-read-only="true"
      cancel-text="Закрыть"
    >
      <HistoryModal ref="risk-history-modal" :uuid="uuid" />
    </ObModal>

    <ObModal
      ref="edit-risk-modal"
      size="medium"
      title="Изменение оценки участника"
      :is-show-controls="false"
    >
      <EditRisk
        :risk="participantRisk"
        :uuid="uuid"
        @openRiskHistory="onOpenRiskHistory"
        @editRisk="onEditRisk"
      />
    </ObModal>

  </div>
</template>

<script>
import api from "@/api";
import { uuid } from "vue-uuid";
import { groupsFieldsSort } from "@/helpers/fields";
import moment from "moment";
import { mapGetters } from "vuex";
import riskIconMixin from "@/mixins/risk-icon";
import obCurrencyMixin from "@/mixins/ob-currency-mixin";

import ObModal from "common-components/src/obComponents/obModal/index";
import ObTable from "common-components/src/obComponents/obTable";
import ObFunctionalPanel from "common-components/src/obComponents/obFuncPanel";
import ObLoader from "common-components/src/obComponents/obLoader";

import ViewValues from "../../modal/view-values";
import HistoryModal from "../../modal/org-history.vue";
import EditRisk from "../../modal/edit-risk.vue";

export default {
  components: {
    ObModal,
    ObTable,
    ObFunctionalPanel,
    ObLoader,
    HistoryModal,
    ViewValues,
    EditRisk
  },
  mixins: [riskIconMixin, obCurrencyMixin],
  computed: {
    ...mapGetters({
      role: "user/role",
      participantUuid: "user/participantUuid",
      isModerator: "user/isModerator"
    }),
    uuid: ({ $route, participantUuid }) => $route.params.uuid || participantUuid,
    notEmptyGroups: ({ groups }) => groups.filter(group => group.fields.length),
    isEditEnabled: ({ participantRisk, isModerator }) => 
      !!participantRisk.riskGroupUuid && isModerator && !participantRisk.isTemporaryRisk
  },
  data() {
    return {
      pending: false,
      error: null,
      domains: [],
      groups: [],
      attaches: [],
      selectedField: {},
      searchQuery: "",
      participantTitle: null,
      participantRisk: {},
      load_data: false,
      optionsTableSaveItem: {
        onSubmit: async (data, value) => {
          await this.onSave(data, value);
        }
      },
      columns: [
        {
          title: "Наименование поля",
          exactWidth: "30%",
          uuid: uuid.v4(),
          slotName: "title",
          _isEnabled: true
        },
        {
          title: "Значение поля",
          html: field => this.getHtmlValue(field),
          action: (field, e) => this.onFieldClick(field, e),
          exactWidth: "30%",
          isEditColumn: true,
          isEditHtml: true,
          uuid: uuid.v4(),
          _isEnabled: true
        },
        {
          title: "Источники данных",
          html: field =>
            field.isAttach ? "" : this.getHtmlSources(field.fieldValues),
          exactWidth: "20%",
          uuid: uuid.v4(),
          _isEnabled: true
        },
        {
          title: "Оценка",
          html: field => (field.isAttach ? "" : this.getHtmlRisks(field)),
          exactWidth: "20%",
          uuid: uuid.v4(),
          _isEnabled: true
        }
      ]
    };
  },
  methods: {
    async downloadFile(fileUuid, fileName) {
      try {
        const { data } = await api.organisations.getFileByUuid(fileUuid);

        const url = window.URL.createObjectURL(new Blob([data]));
        const link = document.createElement("a");

        link.href = url;
        link.setAttribute("download", fileName);
        document.body.appendChild(link);
        link.click();
      } catch (e) {
        console.error(e);

        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных"
        });
      }
    },
    async fetch() {
      this.pending = true;
      try {
        let fieldIndex = 1;

        const { data } = await api.organisations.getParticipantByUuid(this.uuid);

        this.groups = groupsFieldsSort(
          data.domains &&
            data.domains &&
            data.domains[0].groups &&
            data.domains[0].groups
        );
        this.attaches = data.domains[0].links;

        this.groups.push({
          requisiteGroupTitle: "Загруженные файлы",
          fields: this.getAttachFields(),
          "data-attr": "no-th"
        });

        this.participantTitle = data.domains[0].participantTitle;
        this.participantRisk = data.domains[0].risks[0] || {};

        document.title = this.participantTitle;

        const { worker_roles } = await api.users.getUserRoles()
        const isAdministrator = worker_roles.find(role => role.isAdministrator)

        this.groups.forEach(group => {
          this.$set(group, "_isOpen", true);

          group.fields = group.fields
            // Temporary hotfix CMN-1600 (remove filter after BE fix)
            .filter(field => field.fieldTitle !== "Данные о судимости ген.дира" || this.isModerator)
            .map(field => {
              let fieldData;

              if (field.fieldValues?.length) {
                // Added fallback if 'isPriority' is 'false' in every item
                fieldData =
                  field.fieldValues.find(value => value.isPriority) ||
                  field.fieldValues[0];
              }

              const data = {
                ...field,
                index: fieldIndex++,
                valueType: fieldData?.data.valueType || field.dataType,
                editDisable: field.needRiskAssessment || field.isKeyField || field.isAttach || !isAdministrator
              };

              // SB-1767
              if (data.fieldCode === "vat" && !this.isModerator) data.editDisable = true;

              // Backend using "CHECKLIST" notation for both "CHECKLIST" and "CHECKLIST_LIST",
              // so if recognition service wasn't recognized any value for 'fieldValues',
              // needed to checking 'isMultiple' property to manually changing value type
              if (data.dataType === "CHECKLIST" && field.isMultiple) {
                data.valueType = "CHECKLIST_LIST"
              }

              if (data.valueType === "CHECKLIST_LIST") {
                data.displayExp = "name";
                data.value = fieldData?.data.values;
                data.remoteOpts = {
                  method: this.getDictionaryList,
                  arguments: { dictionaryName: field.fieldCode }
                };

                if (fieldData?.data.valuesTitled) {
                  data.initialValue = fieldData.data.valuesTitled.map(item => {
                    return { ...item, name: item.title };
                  });
                }
              }

              return data;
            });
        });

        this.$emit("setData", {
          participantTitle: this.participantTitle,
          participantUuid: this.uuid,
          role: this.role
        });

      } catch (e) {
        this.error = e;

        console.error(e);

        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных"
        });
      }

      this.pending = false;
    },
    async getDictionaryList({ dictionaryName, page, size, query, sort }) {
      try {
        return await api.taskMonitor.getOptions(
          dictionaryName,
          page,
          size,
          query,
          sort
        );
      } catch (e) {
        console.error(e);

        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных"
        });
      }
    },
    getAttachFields() {
      return this.attaches.reduce((attaches, item) => {
        attaches.push({
          isAttach: true,
          fieldTitle: item.docTypeTitle,
          fileName: item.fileName,
          action: () => {
            this.downloadFile(item.fileUuid, item.fileName);
          }
        });

        return attaches;
      }, []);
    },
    async onSave(data, value) {
      try {
        if (data.valueType === "CHECKLIST_LIST") {
          // Covert array value to backend-compatible format
          // eslint-disable-next-line no-useless-escape
          value = `[\"${value.join('", "')}\"]`;
        }

        await api.organisations.saveParticipantCard({
          // 'uuid' using in URLs like '/organizations/[uuid]',
          // 'participantUuid' using on '/profile__card_participent' URL
          participantUuid: this.uuid || this.participantUuid,
          fieldCode: data.fieldCode,
          // Convert DATETIME to DATE
          value:
            data.valueType === "DATE"
              ? moment(value).format("YYYY-MM-DD")
              : value
        });

        this.$notification({
          type: "system_notification_success",
          message: "Данные успешно обновлены"
        });
      } catch (e) {
        console.error(e);

        this.$notification({
          type: "system_notification_error",
          message: "Ошибка обновления данных"
        });
      }
    },
    isResolvedConflict(values) {
      return values.reduce((prev, value) => {
        return prev || value.isPriority;
      }, false);
    },
    getDataByPriority(values) {
      const priotitized =
        values.length > 1
          ? values.find(value => value.isPriority) || values[0]
          : values[0];
      return priotitized.data;
    },
    getValueByPriority(values) {
      const output = this.getDataByPriority(values);

      return output.hasOwnProperty("valuesTitled")
        ? output.valuesTitled
        : output.hasOwnProperty("value")
        ? output.value
        : output.values;
    },
    getHtmlValue(field) {
      let html = "";

      if (field.isAttach) {
        html += `
          <div class="table-cell-attach">
            <i class="icon attach"></i>
            <span>${field.fileName}</span>
          </div>
        `;
      } else {
        if (!field.fieldValues.length) {
          return;
        }

        let priorityFieldData = this.getDataByPriority(field.fieldValues);
        let priorityFieldValues = this.getValueByPriority(field.fieldValues);

        if (field.editDisable && field.valueType.includes("CHECKLIST")) {
          if (!priorityFieldValues?.length) {
            html += this.getUserReadableValue(false, field.editDisable);
          } else {
            if (
              field.fieldCode.includes("okved") &&
              !field.hasOwnProperty("_expanded") &&
              priorityFieldValues.length > 3
            ) {
              this.$set(field, "_expanded", false);
            }

            html = `<div class="list-container">`;

            if (field.hasOwnProperty("_expanded") && !field._expanded) {
              priorityFieldValues = priorityFieldValues.slice(0, 3);
            }

            priorityFieldValues.forEach(value => {
              html += `<div class="list-item">${this.getUserReadableValue(
                (value.code || value.articleNumber) + " – " + value.title
              )}</div>`;
            });

            html += "</div>";

            if (field.hasOwnProperty("_expanded")) {
              html += `<div class="list-expander">${
                field._expanded ? "Свернуть" : "Показать все"
              }</div>`;
            }
          }
        } else if (
            // hotfix for "Сумма исполнительных производств по организации, руб"
            // "Сумма исполнительных производств у гендира, руб" showing 0 if no answer
            priorityFieldData.externalServiceAnswerType === "NO_ANSWER" &&
            (field.fieldCode === "org_enforcement_proceedings_sum" || field.fieldCode === "sum_of_enforcement_proceedings_for_ceo") 
          ) {
          html += this.getUserReadableValue("Нет ответа", field.editDisable);
        } else if (field.valueType === "NUMERIC") {
          html += this.getUserReadableValue(this.formatCurrency(priorityFieldValues), field.editDisable);
        } else {
          html += this.getUserReadableValue(priorityFieldValues, field.editDisable);
        }
      }

      return html;
    },
    getUserReadableValue(value, isEditDisable = false) {
      if (typeof value === "boolean" && isEditDisable) {
        return value ? "Да" : "Нет";
      } else if (typeof value === "boolean") {
        return value;
      } else {
        return value === 0 || value ? value.toString() : "";
      }
    },
    getHtmlRisks(field) {
      let html = "";

      if (field.fieldRisks.length) {
        html = '<div class="risk-container">';

        field.fieldRisks.forEach(
          risk =>
            (html +=
              this.getRiskIcon(risk.riskGroupColor) + " " + risk.activity)
        );

        html += "</div>";
      }

      return html;
    },
    getHtmlSources(fieldValues) {
      return fieldValues
        .reduce((filtered, item) => {
          // Searching for duplicates
          const foundIndex = filtered.findIndex(row => {
            if (row.source.type === "serviceData") {
              return row.source.serviceUuid === item.source.serviceUuid;
            } else if (row.source.type === "participant") {
              // Because of participants have a different names and uuids,
              // but in result looks like 'Заполнено вручную участником',
              // it's unnecessary to have multiple participants in result array
              return row.source.type === item.source.type;
            } else {
              // For any strange cases
              return row.source.title === item.source.title;
            }
          });

          if (~foundIndex) {
            if (item.isPriority) {
              // If duplicate is found, but new item has priority — just remove the old ones
              filtered.splice(foundIndex, 1);
            } else {
              // If new item hasn't priority, skip it
              return filtered;
            }
          }

          filtered.push(item);

          return filtered;
        }, [])
        .map(item => {
          return this.getTitleBySource({
            type: item.source.type,
            title: item.source.title,
            isStrongText: item.isPriority && fieldValues.length > 1
          });
        })
        .join(", ");
    },
    getTitleBySource({ type, title, isStrongText }) {
      let prefix = "Заполнено вручную ";
      let body = "";

      let toStrong = str => `<b>${str}</b>`;

      if (type.includes("domain")) {
        body = "сотрудником СБ";
      } else if (type.includes("participant")) {
        body = "участником";
      } else {
        prefix = "";
        body = title;
      }

      return `<span>${prefix ? `${prefix} ` : ""}${
        isStrongText ? toStrong(body) : body
      }</span>`;
    },
    tableIsShown(index) {
      let grid =
        this.$refs["requisites-grid-" + index] &&
        this.$refs["requisites-grid-" + index][0];
      let data = grid ? grid.currentItems || [] : [];

      return data.length || !this.searchQuery;
    },
    getFieldsModalTitleByValues(data) {
      let values =
        data && data.fieldValues
          ? data.fieldValues.map(item => item.data && item.data.value)
          : [];

      if (Array.from(new Set(values)).length > 1) {
        return "Расхождение в данных";
      } else {
        return "Совпадение в данных";
      }
    },
    // 👂 Events
    onAccordionClick(group) {
      group._isOpen = !group._isOpen;
    },
    onSelect(field) {
      if (!this.isModerator || field.isAttach || field.fieldValues.length < 2) {
        return;
      }

      this.selectedField = field;
      this.$refs["ob-modal-view-values"].open();
    },
    onFieldClick(field, e) {
      if (
        field.hasOwnProperty("_expanded") &&
        e.target.classList.contains("list-expander")
      ) {
        field._expanded = !field._expanded;
      }

      field.isAttach ? field.action(field) : null;
    },
    onStepBack() {
      this.$router.push({ path: "/organizations" });
      document.title = "Участники";
    },
    onSearch(query) {
      this.searchQuery = query;
    },
    onToggleColumnVisibility (column) {
      this.columns.find(col => col.uuid === column.uuid)._isEnabled = column._isEnabled;
    },
    onEdit() {
      this.$refs["edit-risk-modal"].open();
    },
    onEditRisk() {
      this.$refs["edit-risk-modal"].close();
      this.fetch();
    },
    onOpenRiskHistory() {
      this.$refs["org-history"].open();
      this.$refs["risk-history-modal"]
        ? this.$refs["risk-history-modal"].fetch()
        : null;
    },
    onRefresh() {
      this.fetch();
    }
  },
  mounted() {
    this.fetch();
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.organization-page-loader {
  margin: 5vh 0;
  display: flex;
  justify-content: center;
  transition: none;
}

.error {
  padding: 0 20px 20px;
}

.ob-accordion {
  display: flex;
  background: $background-white;
  flex-direction: column;
  width: 100%;

  &__header {
    display: flex;
    width: 100%;
    height: 40px;
    padding-left: 44px;
    border-bottom: 1px solid $lavender;

    &-item {
      display: flex;
      flex-direction: column;
      justify-content: center;
      color: $shale-gray;
      font-size: 11px;
      line-height: 12px;
      font-variant: small-caps;
      text-transform: uppercase;
      flex-basis: 20%;

      &:nth-child(3) {
        flex-basis: 10%;
      }

      &:nth-child(4) {
        flex-basis: 50%;
      }
    }
  }

  &__item {
    display: flex;
    flex-direction: column;
    border-left: none;
    border-right: none;
  }

  &__title {
    padding: 11px 15px;
    color: $color-blue-navy-blue;
    cursor: pointer;
    font-size: 16px;
    border-bottom: 1px solid $lavender;
    background: $light-lavender;
    display: flex;
    align-items: center;

    &-text {
      margin-left: 15px;
    }

    .icon {
      font-size: 20px;

      &.closed {
        transform: rotate(-90deg);
      }
    }
  }

  &__content {
    &-table {
      width: 100%;

      &-row {
        display: flex;
        border-bottom: 1px solid $lavender;
        padding: 8px 0 8px 44px;
        min-height: 40px;
      }

      &-cell {
        @include font-mixin(14px, 20px, 400, $color-text-base);

        display: flex;
        flex-direction: column;
        justify-content: center;
        flex-basis: 20%;

        &:nth-child(3) {
          flex-basis: 10%;
          align-items: center;
        }

        &:nth-child(4) {
          flex-basis: 50%;

          i {
            margin-left: 6px;
          }
        }
      }
    }
  }
}

.resource-grid-tabs {
  padding: 30px 20px 0;
  border-bottom: 1px solid $organizationPage-resource_grid_tabs_border_bottom;
}

.organization-page {
  width: 100%;

  &::v-deep {
    .text-source-grey {
      @include font-mixin(14px, 18px, 400, $gray-slate);
    }

    td {
      > div {
        display: flex;
        align-items: center;
      }
    }

    [data-attr="no-th"] {
      table {
        th {
          display: none;
        }

        td:first-child {
          width: 60%;
        }
      }
    }

    .title-container {
      display: flex;
      align-items: center;

      &__inline {
        display: inline;
      }

      i {
        font-size: 12px;
        display: flex;
        align-items: center;
        justify-content: center;
        height: 12px;
        width: 12px;
      }

      .title-index {
        @include font-mixin(14px, 20px, 400, $color-text-base);

        margin-right: 20px;
      }
    }

    .status-container {
      margin-right: 25px;

      &-empty {
        margin-right: 36px;
      }
    }

    .table-cell-attach {
      width: 100%;
      cursor: pointer;
      display: flex;
      align-items: center;
      color: $color-blue-navy-blue;

      .icon {
        font-size: 16px;
        margin-right: 15px;
      }
    }

    .risk-container {
      display: flex;
      align-items: center;

      .icon[class*="risk-"] {
        font-size: 22px;
      }
    }

    .list-item {
      margin-bottom: 10px;

      &:last-child {
        margin-bottom: 0;
      }
    }

    .list-expander {
      color: $color-blue-navy-blue;
      margin-top: 18px;
      cursor: pointer;
    }
  }
}
</style>
